//Inclusion des librairies .c
extern "C"
{
#include <fxlib.h>
#include "MonochromeLib.h"
#include <stdio.h>
#include <stdlib.h>
#include "serial.h"
#include "memory.h"
}
//Fin des Inclusions
//Inclussion des modules

#include "Initialisation.hpp"
#include "Sprite.hpp"
#include "SpriteRyu.hpp"
#include "SpriteRyuN.hpp"
#include "SpriteKen.hpp"
#include "SpriteKenN.hpp"
#include "Player.hpp"
#include "Fight.hpp"
#include "Affichage.hpp"
#include "IA.hpp"

//Fin des Inclusions

//Dbut du Programme

int Pause()
{
    ML_clear_vram();
    PrintMini(50,25,"PAUSE",1);
    PrintMini(45,35,"F2 : EXIT",1);
    ML_display_vram();
    while(IsKeyDown(KEY_CTRL_F1)){}

    while(1)
    {
       if(IsKeyDown(KEY_CTRL_F2))return 0;
       if(IsKeyDown(KEY_CTRL_F1))return 1;
    }
}

int Fight(combat & game)
{

StockerSpriteRyu();
StockerSpriteKen();
StockerSpriteKenN();
StockerSpriteRyuN();

Player Joueur1;
Player Joueur2;
Feu B1;
Feu B2;

char RRD[]= {"\\\\fls0\\RYU\\RRD"};
char RRG[]= {"\\\\fls0\\RYU\\RRG"};
char RMAVD[]= {"\\\\fls0\\RYU\\RMAVD"};
char RMAVG[]= {"\\\\fls0\\RYU\\RMAVG"};
char RMARD[]= {"\\\\fls0\\RYU\\RMARD"};
char RMARG[]= {"\\\\fls0\\RYU\\RMARG"};
char RDD[]= {"\\\\fls0\\RYU\\RDD"};
char RDG[]= {"\\\\fls0\\RYU\\RDG"};
char RPD[]= {"\\\\fls0\\RYU\\RPD"};
char RPG[]= {"\\\\fls0\\RYU\\RPG"};
char RMD[]= {"\\\\fls0\\RYU\\RMD"};
char RMG[]= {"\\\\fls0\\RYU\\RMG"};
char RF[]= {"\\\\fls0\\RYU\\RF"};
char RAD[]= {"\\\\fls0\\RYU\\RAD"};
char RAG[]= {"\\\\fls0\\RYU\\RAG"};
char RBD[]= {"\\\\fls0\\RYU\\RBD"};
char RBG[]= {"\\\\fls0\\RYU\\RBG"};
char RAPD[]= {"\\\\fls0\\RYU\\RAPD"};
char RAPG[]= {"\\\\fls0\\RYU\\RAPG"};
char RABD[]= {"\\\\fls0\\RYU\\RABD"};
char RABG[]= {"\\\\fls0\\RYU\\RABG"};
char RADD[]= {"\\\\fls0\\RYU\\RADD"};
char RADG[]= {"\\\\fls0\\RYU\\RADG"};
char RPID[]= {"\\\\fls0\\RYU\\RPID"};
char RPIG[]= {"\\\\fls0\\RYU\\RPIG"};
char RAPID[]= {"\\\\fls0\\RYU\\RAPID"};
char RAPIG[]= {"\\\\fls0\\RYU\\RAPIG"};
char RSD[]= {"\\\\fls0\\RYU\\RSD"};
char RSG[]= {"\\\\fls0\\RYU\\RSG"};
char RSP[]= {"\\\\fls0\\RYU\\RSP"};
char RSPI[]= {"\\\\fls0\\RYU\\RSPI"};
char RFEUD[]= {"\\\\fls0\\RYU\\RFEUD"};
char RFEUG[]= {"\\\\fls0\\RYU\\RFEUG"};


int A1122[]={1,1,2,2};
int A12[]={1,2};
int AP[]={1,2,3,4,2};
int API[]={1,2,3,1,1};
int AAP[]={1,2,3,2};
int ASPI[]={1,2,3,4};
int A11[]={1,1};

Sequence RyuReposD( 4, 1, 26, 55, 0, 0,-100, -100, RRD , A1122);
Sequence RyuReposG( 4, 1, 26, 55, 0, 0,-100, -100, RRG , A1122);
Sequence RyuMarcheAvD( 2, 0, 30, 55, 0, 0, -100, -100, RMAVD , A12);
Sequence RyuMarcheAvG( 2, 0, 30, 55, 0, 0, -100, -100, RMAVG , A12);
Sequence RyuMarcheArD( 2, 0, 30, 55, 0, 0, -100, -100, RMARD , A12);
Sequence RyuMarcheArG( 2, 0, 30, 55, 0, 0, -100, -100, RMARG , A12);
Sequence RyuDegatD( 4, 0, 40, 55, 0, 0, -100, -100, RDD , A12);
Sequence RyuDegatG( 4, 0, 40, 55, 0, 0, -100, -100, RDG , A12);
Sequence RyuPoingD( 5, 0, 46, 55, 0, 0, 43, 13, RPD , AP);
Sequence RyuPoingG( 5, 0, 46, 55, -23, 0, 3, 13, RPG , AP);
Sequence RyuMortD( 2, 0, 55, 20, 0, 35, -100, -100, RMD , A11);
Sequence RyuMortG( 2, 0, 55, 20, 0, 35, -100, -100, RMG , A11);
Sequence RyuFinalD( 2, 1, 26, 55, 0, 0, -100, -100, RF , A11);
Sequence RyuAccroupiD( 2, 1, 32, 40, 0, 15, -100, -100, RAD , A11);
Sequence RyuAccroupiG( 2, 1, 32, 40, 0, 15, -100, -100, RAG , A11);
Sequence RyuBloqueD( 2, 1, 28, 55, 0, 0, -100, -100, RBD , A11);
Sequence RyuBloqueG( 2, 1, 28, 55, 0, 0, -100, -100, RBG , A11);
Sequence RyuAPoingD( 5, 0, 45, 40, 0, 15, 40, 16, RAPD , AAP);
Sequence RyuAPoingG( 5, 0, 45, 40, -15, 15, 4, 16, RAPG , AAP);
Sequence RyuABloqueD( 2, 1, 32, 40, 0, 15, -100, -100, RABD , A11);
Sequence RyuABloqueG( 2, 1, 32, 40, 0, 15, -100, -100, RABG , A11);
Sequence RyuADegatD( 4, 0, 36, 40, 0, 15, -100, -100, RADD , A12);
Sequence RyuADegatG( 4, 0, 36, 40, -6, 15, -100, -100, RADG , A12);
Sequence RyuPiedD( 5, 0, 54, 55, -5, 0, 53, 13, RPID, API);
Sequence RyuPiedG( 5, 0, 54, 55, -23, 0, 0, 13, RPIG , API);
Sequence RyuAPiedD( 5, 0, 55, 40, -7, 15, 50, 38, RAPID , API);
Sequence RyuAPiedG( 5, 0, 55, 40, -16, 15, 5, 38, RAPIG , API);
Sequence RyuSautD( 2, 1, 23, 44, 0, -11, -100, -100, RSD , A1122);
Sequence RyuSautG( 2, 1, 23, 44, -3, -11, -100, -100, RSG , A11);
Sequence RyuSPied( 6, 1, 62, 60, -22, -10, -100, -100,RSPI , ASPI);
Sequence RyuSPoing( 4, 1, 30, 72, 0, -20, -100, -100, RSP , A12);
Sequence RyuFeuD( 2, 0, 44, 48, 0, 7, 10, 25, RFEUD , A12);
Sequence RyuFeuG( 2, 0, 44, 48, -18, 7, 35, 25,RFEUG , A12);

Sequence SpriteRyu[]={ RyuReposD , RyuReposG , RyuMarcheAvD , RyuMarcheAvG , RyuMarcheArD , RyuMarcheArG , RyuDegatD , RyuDegatG , RyuPoingD , RyuPoingG , RyuMortD , RyuMortG , RyuFinalD, RyuAccroupiD , RyuAccroupiG , RyuBloqueD , RyuBloqueG, RyuAPoingD, RyuAPoingG , RyuABloqueD, RyuABloqueG, RyuADegatD , RyuADegatG, RyuPiedD , RyuPiedG ,RyuAPiedD ,RyuAPiedG,RyuSautD,RyuSautG,RyuSPied,RyuSPoing,RyuFeuD,RyuFeuG};

char KRD[]= {"\\\\fls0\\KEN\\KRD"};
char KRG[]= {"\\\\fls0\\KEN\\KRG"};
char KMAVD[]= {"\\\\fls0\\KEN\\KMAVD"};
char KMAVG[]= {"\\\\fls0\\KEN\\KMAVG"};
char KMARD[]= {"\\\\fls0\\KEN\\KMARD"};
char KMARG[]= {"\\\\fls0\\KEN\\KMARG"};
char KDD[]= {"\\\\fls0\\KEN\\KDD"};
char KDG[]= {"\\\\fls0\\KEN\\KDG"};
char KPD[]= {"\\\\fls0\\KEN\\KPD"};
char KPG[]= {"\\\\fls0\\KEN\\KPG"};
char KMD[]= {"\\\\fls0\\KEN\\KMD"};
char KMG[]= {"\\\\fls0\\KEN\\KMG"};
char KF[]= {"\\\\fls0\\KEN\\KF"};
char KAD[]= {"\\\\fls0\\KEN\\KAD"};
char KAG[]= {"\\\\fls0\\KEN\\KAG"};
char KBD[]= {"\\\\fls0\\KEN\\KBD"};
char KBG[]= {"\\\\fls0\\KEN\\KBG"};
char KAPD[]= {"\\\\fls0\\KEN\\KAPD"};
char KAPG[]= {"\\\\fls0\\KEN\\KAPG"};
char KABD[]= {"\\\\fls0\\KEN\\KABD"};
char KABG[]= {"\\\\fls0\\KEN\\KABG"};
char KADD[]= {"\\\\fls0\\KEN\\KADD"};
char KADG[]= {"\\\\fls0\\KEN\\KADG"};
char KPID[]= {"\\\\fls0\\KEN\\KPID"};
char KPIG[]= {"\\\\fls0\\KEN\\KPIG"};
char KAPID[]= {"\\\\fls0\\KEN\\KAPID"};
char KAPIG[]= {"\\\\fls0\\KEN\\KAPIG"};
char KSD[]= {"\\\\fls0\\KEN\\KSD"};
char KSG[]= {"\\\\fls0\\KEN\\KSG"};
char KSP[]= {"\\\\fls0\\KEN\\KSP"};
char KSPI[]= {"\\\\fls0\\KEN\\KSPI"};
char KFEUD[]= {"\\\\fls0\\KEN\\KFEUD"};
char KFEUG[]= {"\\\\fls0\\KEN\\KFEUG"};

Sequence KenReposD( 4, 1, 26, 55, 0, 0,-100, -100, KRD , A1122);
Sequence KenReposG( 4, 1, 26, 55, 0, 0,-100, -100, KRG , A1122);
Sequence KenMarcheAvD( 2, 0, 30, 55, 0, 0, -100, -100, KMAVD , A12);
Sequence KenMarcheAvG( 2, 0, 30, 55, 0, 0, -100, -100, KMAVG , A12);
Sequence KenMarcheArD( 2, 0, 30, 55, 0, 0, -100, -100, KMARD , A12);
Sequence KenMarcheArG( 2, 0, 30, 55, 0, 0, -100, -100, KMARG , A12);
Sequence KenDegatD( 4, 0, 40, 55, 0, 0, -100, -100, KDD , A12);
Sequence KenDegatG( 4, 0, 40, 55, 0, 0, -100, -100, KDG , A12);
Sequence KenPoingD( 5, 0, 46, 55, 0, 0, 43, 13, KPD , AP);
Sequence KenPoingG( 5, 0, 46, 55, -23, 0, 3, 13, KPG , AP);
Sequence KenMortD( 2, 0, 55, 20, 0, 35, -100, -100, KMD , A11);
Sequence KenMortG( 2, 0, 55, 20, 0, 35, -100, -100, KMG , A11);
Sequence KenFinalD( 2, 1, 26, 55, 0, 0, -100, -100, KF , A11);
Sequence KenAccroupiD( 2, 1, 32, 40, 0, 15, -100, -100, KAD , A11);
Sequence KenAccroupiG( 2, 1, 32, 40, 0, 15, -100, -100, KAG , A11);
Sequence KenBloqueD( 2, 1, 28, 55, 0, 0, -100, -100, KBD , A11);
Sequence KenBloqueG( 2, 1, 28, 55, 0, 0, -100, -100, KBG , A11);
Sequence KenAPoingD( 5, 0, 45, 40, 0, 15, 40, 16, KAPD , AAP);
Sequence KenAPoingG( 5, 0, 45, 40, -15, 15, 4, 16, KAPG , AAP);
Sequence KenABloqueD( 2, 1, 32, 40, 0, 15, -100, -100, KABD , A11);
Sequence KenABloqueG( 2, 1, 32, 40, 0, 15, -100, -100, KABG , A11);
Sequence KenADegatD( 4, 0, 36, 40, 0, 15, -100, -100, KADD , A12);
Sequence KenADegatG( 4, 0, 36, 40, -6, 15, -100, -100, KADG , A12);
Sequence KenPiedD( 5, 0, 54, 55, -5, 0, 53, 13, KPID, API);
Sequence KenPiedG( 5, 0, 54, 55, -23, 0, 0, 13, KPIG , API);
Sequence KenAPiedD( 5, 0, 55, 40, -7, 15, 50, 38, KAPID , API);
Sequence KenAPiedG( 5, 0, 55, 40, -16, 15, 5, 38, KAPIG , API);
Sequence KenSautD( 2, 1, 23, 44, 0, -11, -100, -100, KSD , A1122);
Sequence KenSautG( 2, 1, 23, 44, -3, -11, -100, -100, KSG , A11);
Sequence KenSPied( 6, 1, 62, 60, -22, -10, -100, -100,KSPI , ASPI);
Sequence KenSPoing( 4, 1, 30, 72, 0, -20, -100, -100, KSP , A12);
Sequence KenFeuD( 2, 0, 44, 48, 0, 7, 10, 25, KFEUD , A12);
Sequence KenFeuG( 2, 0, 44, 48, -18, 7, 35, 25,KFEUG , A12);


Sequence SpriteKen[]={ KenReposD , KenReposG , KenMarcheAvD , KenMarcheAvG , KenMarcheArD , KenMarcheArG , KenDegatD , KenDegatG , KenPoingD , KenPoingG , KenMortD , KenMortG , KenFinalD, KenAccroupiD , KenAccroupiG , KenBloqueD , KenBloqueG, KenAPoingD, KenAPoingG , KenABloqueD, KenABloqueG, KenADegatD , KenADegatG, KenPiedD , KenPiedG ,KenAPiedD ,KenAPiedG,KenSautD,KenSautG,KenSPied,KenSPoing,KenFeuD,KenFeuG};


int jeu=1;
Joueur1.SPlayer.round=0;
Joueur2.SPlayer.round=0;

while(jeu==1)
{
    unsigned int key;
    int gagnant=0;
    int timeur=10;
    int endtimeur=30;
    int distance;
    int reaction=0;
    game.timee=game.time;
    if(game.champion1 == 1)Joueur1.Initialise( game.handicapJ1 ,(Sequence*)  &SpriteRyu ,1 ,(Feu*) &B1);
    if(game.champion1 == 2)Joueur1.Initialise( game.handicapJ1 ,(Sequence*)  &SpriteKen ,1 ,(Feu*) &B1);
    if(game.champion2 == 1)Joueur2.Initialise( game.handicapJ2 ,(Sequence*)  &SpriteRyu ,2 ,(Feu*) &B2);
    if(game.champion2 == 2)Joueur2.Initialise( game.handicapJ2 ,(Sequence*)  &SpriteKen ,2 ,(Feu*) &B2);
    Joueur1.BJ->Go(-100,-100,0,0);
    Joueur2.BJ->Go(-100,-100,0,0);
    game.endround =0;
    Affichage(Joueur1,Joueur2,game);
    Joueur1.PAffichage();
    int fin=0;

    while(fin == 0)
    {
    Serial_ClearReceiveBuffer();
    Serial_ClearTransmitBuffer();


    if(IsKeyDown(KEY_CTRL_F1))jeu = Pause();
    if(jeu == 0)fin =1;
    if(Joueur1.Encour == 0 && Joueur1.etat != 12)
        {
            Joueur1.Repos();

              if (game.ia == 0)
              {
                    Joueur1.attaque=0;
                    if(IsKeyDown(KEY_CTRL_SHIFT)){Joueur1.HPlayer.direction=2;Joueur1.etat=1;}
                    if(IsKeyDown(KEY_CTRL_ALPHA)){Joueur1.HPlayer.direction=1;Joueur1.etat=0;}
                    if(IsKeyDown(KEY_CHAR_1)){Joueur1.Accroupi();Joueur1.accroup = 1;}
                    if(IsKeyDown(KEY_CHAR_0)){Joueur1.Saut();}
                    if(IsKeyDown(KEY_CHAR_DP) && Joueur1.accroup != 1){if(Joueur1.HPlayer.direction == 1) Joueur1.MarcheAvant();if(Joueur1.HPlayer.direction == 2) Joueur1.MarcheArriere();}
                    if(IsKeyDown(KEY_CHAR_2)  && Joueur1.accroup != 1){ if(Joueur1.HPlayer.direction == 1)Joueur1.MarcheArriere();if(Joueur1.HPlayer.direction == 2)Joueur1.MarcheAvant();}
                    if(IsKeyDown(KEY_CTRL_OPTN)){Joueur1.Poing();Joueur1.attaque=1;}
                    if(IsKeyDown(KEY_CHAR_SQUARE)){Joueur1.Pied();Joueur1.attaque=1;}
                    if(IsKeyDown(KEY_CHAR_LOG)){Joueur1.Bloque();Joueur1.attaque=1;}
                    if(IsKeyDown(KEY_CTRL_OPTN)&& IsKeyDown(KEY_CHAR_SQUARE)){Joueur1.Fire();Joueur1.attaque=1;}
                    if (Joueur1.SPlayer.vie <= 0){Joueur1.Mort();game.endround=1;gagnant=2;}
              }


              if (game.ia == 1)
              {
                    Joueur1.attaque=0;
                    if(IsKeyDown(KEY_CTRL_ALPHA)){Joueur1.HPlayer.direction=2;Joueur1.etat=1;}
                    if(IsKeyDown(KEY_CHAR_SQUARE)){Joueur1.HPlayer.direction=1;Joueur1.etat=0;}
                    if(IsKeyDown(KEY_CTRL_DOWN)){Joueur1.Accroupi();Joueur1.accroup = 1;}
                    if(IsKeyDown(KEY_CTRL_UP)){Joueur1.Saut();}
                    if(IsKeyDown(KEY_CTRL_RIGHT) && Joueur1.accroup != 1){if(Joueur1.HPlayer.direction == 1) Joueur1.MarcheAvant();if(Joueur1.HPlayer.direction == 2) Joueur1.MarcheArriere();}
                    if(IsKeyDown(KEY_CTRL_LEFT)  && Joueur1.accroup != 1){ if(Joueur1.HPlayer.direction == 1)Joueur1.MarcheArriere();if(Joueur1.HPlayer.direction == 2)Joueur1.MarcheAvant();}
                    if(IsKeyDown(KEY_CTRL_SHIFT)){Joueur1.Poing();Joueur1.attaque=1;}
                    if(IsKeyDown(KEY_CTRL_VARS)){Joueur1.Pied();Joueur1.attaque=1;}
                    if(IsKeyDown(KEY_CTRL_OPTN)){Joueur1.Bloque();}
                    if(IsKeyDown(KEY_CTRL_SHIFT)&& IsKeyDown(KEY_CTRL_VARS)){Joueur1.Fire();Joueur1.attaque=1;}
                    if (Joueur1.SPlayer.vie <= 0){Joueur1.Mort();game.endround=1;gagnant=2;}
              }

        }


    if(Joueur2.Encour == 0 && Joueur2.etat != 12)
        {

            if(game.ia == 0)
            {
                Joueur2.Repos();
                if(IsKeyDown(KEY_CHAR_COS)){Joueur2.HPlayer.direction=2;Joueur2.etat=1;}
                if(IsKeyDown(KEY_CHAR_COMMA)){Joueur2.HPlayer.direction=1;Joueur2.etat=0;}
                if(IsKeyDown(KEY_CTRL_EXE)){Joueur2.Accroupi();Joueur2.accroup = 1;}
                if(IsKeyDown(KEY_CHAR_MINUS)){Joueur2.Saut();}
                if(IsKeyDown(KEY_CHAR_PLUS) && Joueur2.accroup != 1){if(Joueur2.HPlayer.direction == 1) Joueur2.MarcheAvant();if(Joueur2.HPlayer.direction == 2) Joueur2.MarcheArriere();}
                if(IsKeyDown(KEY_CHAR_EXP)  && Joueur2.accroup != 1){ if(Joueur2.HPlayer.direction == 1)Joueur2.MarcheArriere();if(Joueur2.HPlayer.direction == 2)Joueur2.MarcheAvant();}
                if(IsKeyDown(KEY_CHAR_RPAR)){Joueur2.Poing();}
                if(IsKeyDown(KEY_CHAR_SIN)){Joueur2.Pied();}
                if(IsKeyDown(KEY_CTRL_EXIT)){Joueur2.Bloque();}
                if(IsKeyDown(KEY_CHAR_RPAR)&& IsKeyDown(KEY_CHAR_SIN)){Joueur2.Fire();}
                if (Joueur2.SPlayer.vie <= 0){Joueur2.Mort();game.endround=1;gagnant=1;}
            }

            if(game.ia == 1)
            {
                IAE(Joueur1, Joueur2 ,game);
            //if(game.iadifficulte==1)IAE(Joueur1, Joueur2 ,game);
            //if(game.iadifficulte==2)IAM(Joueur1, Joueur2 ,game);
            //if(game.iadifficulte==3)IAD(Joueur1, Joueur2 ,game);
            if(Joueur2.SPlayer.vie <= 0){Joueur2.Mort();game.endround=1;gagnant=1;}

            }
        }
    if(Joueur1.HPlayer.x < 0){Joueur1.HPlayer.x=0;}
    if(Joueur1.HPlayer.x > 100){Joueur1.HPlayer.x=100;}

    if(Joueur2.HPlayer.x < 0){Joueur2.HPlayer.x=0;}
    if(Joueur2.HPlayer.x > 100){Joueur2.HPlayer.x=100;}

    Joueur1.Gravite();
    Joueur2.Gravite();

    ML_clear_vram();
    Joueur1.PAffichageN();
    Joueur2.PAffichageN();
    Joueur1.Frapper(Joueur2);
    Joueur2.Frapper(Joueur1);
    Joueur1.BJ->Mouvement(Joueur2.HPlayer,Joueur2.SPlayer,Joueur2.Sprite[Joueur2.etat]);
    Joueur2.BJ->Mouvement(Joueur1.HPlayer,Joueur1.SPlayer,Joueur1.Sprite[Joueur1.etat]);
    Affichage(Joueur1,Joueur2,game);
    Joueur1.PAffichage();
    Joueur2.PAffichage();
    ML_display_vram();


    if(game.endround == 1){Affichend(Joueur1 , Joueur2 ,gagnant);endtimeur--;if(endtimeur <=0){fin =1;}}
    ML_display_vram();
    if(game.endround == 0)timeur--;
    if(timeur == 0)
    {
       game.timee--;
       timeur=13;
    }

    if(game.timee <= 0){ game.timee=0;game.endround=1;gagnant=0;}
    }
    ML_clear_vram();
    Affichage(Joueur1,Joueur2,game);
    Joueur1.PAffichage();
    Joueur2.PAffichage();
    ML_display_vram();
    Sleep(2000);
    if(gagnant==1)Joueur1.SPlayer.round++;
    if(gagnant==2)Joueur2.SPlayer.round++;
    if(Joueur1.SPlayer.round== game.roundmax)jeu=0;
    if(Joueur2.SPlayer.round== game.roundmax)jeu=0;
}
return 1;
}
//Fin du Programme

