extern "C"
{
#include <fxlib.h>
#include "MonochromeLib.h"
#include <stdio.h>
#include <stdlib.h>
#include "memory.h"
}
#include "Initialisation.hpp"
#include "Sprite.hpp"
#include"Player.hpp"
#include"Menu.hpp"


Sequence::Sequence(int NI, int B, int X, int Y, int OX, int OY, int PX, int PY, char * ad , int * anim)
{
        this -> NImage=NI;
        this -> Boucle=B;
        this -> size_x=X;
        this -> size_y=Y;
        this -> ox=OX;
        this -> oy=OY;
        this -> px=PX;
        this -> py=PY;
        this -> Adresse = ad;
        this -> Animation = anim;
};

void Player::Initialise(int v , Sequence* TImage , int clan, Feu * BT)
{
        this -> SPlayer.vie=v;

        if (clan ==1)
        {
        this -> HPlayer.x = 10;
        this -> HPlayer.y = 7;
        this -> HPlayer.direction=1;
        this -> etat=0;
        }

         if (clan ==2)
        {
        this -> HPlayer.x = 80;
        this -> HPlayer.y = 7;
        this -> HPlayer.direction=2;
        this -> etat=1;
        }

        this -> HPlayer.sizex=26;
        this -> HPlayer.sizey=55;
        this -> etatbuffer = etat;
        this -> compteur=0;
        this -> checktouche=0;
        this -> HPlayer.ImageP = -1;
        this -> Sprite = TImage; //Copie l'adresse du tableau de Sequence
        GPlayer.v_saut = 0;
        GPlayer.v_grav = 0;
        GPlayer.v_y = GPlayer.v_saut;
        this ->BJ=BT;
        SPlayer.ready=0;
        SPlayer.rage=0;

}

void Player::Deplacement(int a, int b) //Deplace le joueur de x,y.
{
    HPlayer.x = HPlayer.x + a;
    HPlayer.y = HPlayer.y + b;
}

int Player::PAffichageN()
{
    const unsigned char * Bitmap;

    if(etatbuffer != etat)
    {
        etatbuffer=etat;
        special=10;
        compteur = 0;

    }

    Bitmap = chargerSpriteN(Sprite[etat] , compteur);

    ML_bmp_or_cl((const unsigned char*) Bitmap, HPlayer.x + Sprite[etat].ox, HPlayer.y + Sprite[etat].oy, Sprite[etat].size_x , Sprite[etat].size_y);
    free((void *)Bitmap);


    if(HPlayer.ImageP == -2)
        {
            if(compteur==0){Sprite[30].px=5;Sprite[30].py=40;}
            if(compteur==1){Sprite[30].px=25;Sprite[30].py=40;}
        }
    if(HPlayer.ImageP == -3)
        {
            if(compteur==0){Sprite[29].px=-100;Sprite[29].py=-100;}
            if(compteur==1){Sprite[29].px=-100;Sprite[29].py=-100;}
            if(compteur==2){Sprite[29].px=1;Sprite[29].py=30;}
            if(compteur==3){Sprite[29].px=30;Sprite[29].py=30;}
            if(compteur==4){Sprite[29].px=30;Sprite[29].py=30;}
            if(compteur==5){Sprite[29].px=60;Sprite[29].py=30;}

        }
    if(HPlayer.ImageP == -4)
        {
         this ->special--;
            if(special > 0)
                {
                    compteur = 0;
                    const unsigned char Coup[]={0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xf3, 0xcf, 0xf0, 0xf, 0xe0, 0xf, 0xc0, 0xf, 0xe0, 0x3, 0xe0, 0x7, 0xc0, 0xf, 0xe0, 0xf, 0xf8, 0x7, 0xf8, 0x7, 0xf9, 0xcf, 0xf7, 0xef, 0xff, 0xff, };
                    const unsigned char CoupN[]={0x10, 0x0, 0x18, 0x10, 0x1c, 0x30, 0x1f, 0xf8, 0x1f, 0xf8, 0x3f, 0xf8, 0x7f, 0xfc, 0x3f, 0xff, 0x3f, 0xfe, 0x7f, 0xf8, 0x3f, 0xf8, 0x1f, 0xfc, 0xf, 0xfe, 0xf, 0xf8, 0x1e, 0x38, 0x18, 0x10, };
                    ML_bmp_or_cl((const unsigned char *)CoupN, Sprite[etat].px + Sprite[etat].ox + HPlayer.x - 8, Sprite[etat].py + Sprite[etat].oy + HPlayer.y - 8, 16, 16);
                    ML_bmp_and_cl((const unsigned char *)Coup, Sprite[etat].px + Sprite[etat].ox + HPlayer.x - 8, Sprite[etat].py + Sprite[etat].oy + HPlayer.y - 8, 16, 16);
                }
                else
                {
                    compteur=1;
                    if(special == 0)
                    {
                   if(HPlayer.direction == 1)BJ->Go(Sprite[etat].ox + HPlayer.x - 4+35,Sprite[etat].oy + HPlayer.y - 8 +17,1,10);
                   if(HPlayer.direction == 2)BJ->Go(Sprite[etat].ox + HPlayer.x  ,Sprite[etat].oy + HPlayer.y - 8 +17,2,10);
                    }
                }
        }


    return 0;
}

int Player::PAffichage()
{
    const unsigned char * Bitmap;

    Bitmap = chargerSprite(Sprite[etat] , compteur);

    ML_bmp_and_cl((const unsigned char*) Bitmap, HPlayer.x + Sprite[etat].ox, HPlayer.y + Sprite[etat].oy, Sprite[etat].size_x , Sprite[etat].size_y);
    free((void *)Bitmap);

    this ->compteur ++;
    this ->Encour =1;
    if (compteur == Sprite[etat].NImage)
    {
        compteur = 0;
        this ->Encour =0;
    }

    if(Sprite[etat].Boucle == 1) this ->Encour =0;
    if(compteur == HPlayer.ImageP-1 ||HPlayer.ImageP <-1){checktouche=1;}
    return 0;
}

int Player::Repos()
{
    if(HPlayer.direction==1)etat=0;

    if(HPlayer.direction==2)etat=1;
    this -> HPlayer.ImageP = -1;
    this -> accroup=0;
    return 1;
}

int Player::MarcheAvant()
{
    if(HPlayer.direction==1)
    {
        etat=2;
        Deplacement(5,0) ;
    }

    if(HPlayer.direction==2)
    {
        etat=3;
        Deplacement(-5,0) ;
    }
     this -> HPlayer.ImageP = -1;
    return 1;
}

int Player::MarcheArriere()
{
    if(HPlayer.direction==1)
    {
        etat=4;
        Deplacement(-5,0) ;
    }

    if(HPlayer.direction==2)
    {
        etat=5;
        Deplacement(5,0) ;
    }
     this -> HPlayer.ImageP = -1;
    return 1;
}


int Player::Poing()
{
    if(HPlayer.direction==1 && etat != 13 && GPlayer.ground == 1 )etat=8;

    if(HPlayer.direction==2 && etat != 14 && GPlayer.ground == 1 )etat=9;
    if(HPlayer.direction==1 && etat == 13)etat=17;

    if(HPlayer.direction==2 && etat == 14)etat=18;
    HPlayer.ImageP = 4;

    if(GPlayer.ground == 0 && GPlayer.v_y < 0)
        {
            etat=30;HPlayer.ImageP = -2;
        }

return 1;

}
int Player::Pied()
{
    if(HPlayer.direction==1 && etat != 13 && GPlayer.ground == 1 )etat=23;

    if(HPlayer.direction==2 && etat != 14 && GPlayer.ground == 1 )etat=24;
    if(HPlayer.direction==1 && etat == 13)etat=25;

    if(HPlayer.direction==2 && etat == 14)etat=26;
    HPlayer.ImageP = 3;

    if(GPlayer.ground == 0 && GPlayer.v_y > 0)
    {
     etat=29;HPlayer.ImageP = -3;
    }

return 1;
}
int Player::Accroupi()
{
    if(HPlayer.direction==1)etat=13;

    if(HPlayer.direction==2)etat=14;
return 1;
}
int Player::Bloque()
{
    if(HPlayer.direction==1 && etat != 13 && etat != 27 && etat != 28)etat=15;

    if(HPlayer.direction==2 && etat != 14 && etat != 27 && etat != 28)etat=16;
    if(HPlayer.direction==1 && etat == 13)etat=19;

    if(HPlayer.direction==2 && etat == 14)etat=20;

return 1;
}
int Player::Degat()
{
    if(HPlayer.direction==1 && etat != 13)etat=6;

    if(HPlayer.direction==2 && etat != 14)etat=7;
    if(HPlayer.direction==1 && etat == 13)etat=21;

    if(HPlayer.direction==2 && etat == 14)etat=22;

 this -> HPlayer.ImageP = -1;
return 1;
}
int Player::Mort()
{
    if(HPlayer.direction==1)etat=10;

    if(HPlayer.direction==2)etat=11;

return 1;
}
int Player::Collision(Player & JoueurT)
{
      if (Sprite[etat].px + Sprite[etat].ox + HPlayer.x >= JoueurT.HPlayer.x + JoueurT.Sprite[JoueurT.etat].ox
    && Sprite[etat].px +  Sprite[etat].ox + HPlayer.x  < JoueurT.HPlayer.x + JoueurT.Sprite[JoueurT.etat].size_x + JoueurT.Sprite[JoueurT.etat].ox
    && Sprite[etat].py + Sprite[etat].oy + HPlayer.y  >= JoueurT.HPlayer.y + JoueurT.Sprite[JoueurT.etat].oy
    && Sprite[etat].py + Sprite[etat].oy + HPlayer.y < JoueurT.HPlayer.y + JoueurT.Sprite[JoueurT.etat].size_y + JoueurT.Sprite[JoueurT.etat].oy)
       return 1;
   else
       return 0;
}

int Player::Frapper( Player & J2)
{
    const unsigned char Coup[]={0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xf3, 0xcf, 0xf0, 0xf, 0xe0, 0xf, 0xc0, 0xf, 0xe0, 0x3, 0xe0, 0x7, 0xc0, 0xf, 0xe0, 0xf, 0xf8, 0x7, 0xf8, 0x7, 0xf9, 0xcf, 0xf7, 0xef, 0xff, 0xff, };
    const unsigned char CoupN[]={0x10, 0x0, 0x18, 0x10, 0x1c, 0x30, 0x1f, 0xf8, 0x1f, 0xf8, 0x3f, 0xf8, 0x7f, 0xfc, 0x3f, 0xff, 0x3f, 0xfe, 0x7f, 0xf8, 0x3f, 0xf8, 0x1f, 0xfc, 0xf, 0xfe, 0xf, 0xf8, 0x1e, 0x38, 0x18, 0x10, };

    if(this ->checktouche == 1 && J2.SPlayer.vie> 0)
    {

        if(this ->Collision(J2))
        {
            if((J2.HPlayer.direction-HPlayer.direction==1 || J2.HPlayer.direction-HPlayer.direction==-1 )  &&  (J2.etat==15 ||J2.etat==16 && ( etat != 13 && etat!= 14 && etat!= 17 && etat!= 18 && etat!= 19 && etat!= 20 && etat!= 25 && etat!= 26))  ||  (J2.etat==19 ||J2.etat==20 && (etat== 13|| etat== 14|| etat== 17|| etat== 18||  etat== 19|| etat== 20)))
            {}
            else
            {
            ML_bmp_or_cl((const unsigned char *)CoupN, Sprite[etat].px + Sprite[etat].ox + HPlayer.x - 8, Sprite[etat].py + Sprite[etat].oy + HPlayer.y - 8, 16, 16);
            ML_bmp_and_cl((const unsigned char *)Coup, Sprite[etat].px + Sprite[etat].ox + HPlayer.x - 8, Sprite[etat].py + Sprite[etat].oy + HPlayer.y - 8, 16, 16);
            SPlayer.rage += 10;
            if(SPlayer.rage >= 100){SPlayer.rage = 100;SPlayer.ready=1;}else SPlayer.ready=0;
            J2.Degat();
            J2.SPlayer.vie = J2.SPlayer.vie-5;
            if (J2.SPlayer.vie < 0){J2.SPlayer.vie = 0; J2.Mort();}
            }
        }

    }
    this ->checktouche=0;
    return 1;
}

int Player::Avancer( Player & J2)
{
    if(HPlayer.x - J2.HPlayer.x < 0 ){if(HPlayer.direction == 1) MarcheAvant();if(HPlayer.direction == 2) MarcheArriere();}
    if(HPlayer.x - J2.HPlayer.x > 0 ){if(HPlayer.direction == 1) MarcheArriere();if(HPlayer.direction == 2) MarcheAvant();}
    return 1;
}

int Player::Reculer( Player & J2)
{
    if(HPlayer.x - J2.HPlayer.x > 0 ){if(HPlayer.direction == 1) MarcheAvant();if(HPlayer.direction == 2) MarcheArriere();}
    if(HPlayer.x - J2.HPlayer.x < 0 ){if(HPlayer.direction == 1) MarcheArriere();if(HPlayer.direction == 2) MarcheAvant();}
    return 1;
}

int Player::Gravite()
{
    if(HPlayer.y >= 7 ){GPlayer.ground = 1; HPlayer.y=7;}
    else
    {
        GPlayer.ground = 0;
        HPlayer.y = HPlayer.y + GPlayer.v_y;
        GPlayer.v_y = GPlayer.v_y + GPlayer.v_grav;
        if(HPlayer.direction==1 && etat != 29 && etat != 30 )etat=27;
        if(HPlayer.direction==2 && etat != 29 && etat != 30 )etat=28;
    }
    return 1;
}

int Player::Saut()
{
if(GPlayer.ground == 1)
{
    GPlayer.v_saut = -5;
    GPlayer.v_grav = 0.5;
    GPlayer.v_y = GPlayer.v_saut;
    HPlayer.y = HPlayer.y + GPlayer.v_y;
    GPlayer.v_y = GPlayer.v_y + GPlayer.v_grav;
    if(HPlayer.direction==1)etat=27;
    if(HPlayer.direction==2)etat=28;
}
if(HPlayer.direction==1)etat=27;
if(HPlayer.direction==2)etat=28;
return 1;
}

int Player::Fire()
{
       if(SPlayer.ready==1)
       {
        if(HPlayer.direction==1)etat=31;
        if(HPlayer.direction==2)etat=32;
        if(special < -2)special=10;
        this -> HPlayer.ImageP = -4;
        SPlayer.ready=0;
        SPlayer.rage=0;
       }
    return 1;
}

int Feu::Go(int X,int Y,int D,int V)
{
    this ->x=X;
    this ->y=Y;
    this ->direction=D;
    this ->vitesse=V;
    return 1;
}
int Feu::Mouvement( Hitbox & HJ2 , Stat & SJ2 , Sequence & SeJ2)
{
const unsigned char FeuD[]={0xff, 0xc3, 0x81, 0xb9, 0x81, 0xc3, 0xff, };
const unsigned char FeuG[]={0xff, 0xc3, 0x81, 0x9d, 0x81, 0xc3, 0xff, };
const unsigned char FeuN[]={0x3c, 0x7e, 0xff, 0xff, 0xff, 0x7e, 0x3c, };


  if(direction == 1)x=x+vitesse;
  if(direction == 2)x=x-vitesse;
  ML_bmp_or_cl((const unsigned char *)FeuN, x, y, 8, 7);
  if(direction == 1)ML_bmp_and_cl((const unsigned char *)FeuD, x, y, 8, 7);
  if(direction == 2)ML_bmp_and_cl((const unsigned char *)FeuG, x, y, 8, 7);
  if(x<0 || x>120){Go(-100,-100,0,0);}

        if    ((x+ 8 >= HJ2.x + SeJ2.ox)
            && (x + 8 < HJ2.x + SeJ2.size_x + SeJ2.ox)
            && (y + 4  >= HJ2.y + SeJ2.oy)
            && (y + 4 < HJ2.y + SeJ2.size_y + SeJ2.oy)
              )
      {
         SJ2.vie = SJ2.vie-25;if(SJ2.vie <0)SJ2.vie=0;
         Go(-100,-100,0,0);
      }

    return 1;
}
