extern "C"
{
#include <fxlib.h>
#include <MonochromeLib.h>
#include <stdio.h>
#include <stdlib.h>
#include "serial.h"
}
//Fin des Inclusions
//Inclussion des Modules
#include "Initialisation.hpp"
#include "Menu.hpp"
//Fin des Modules


extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    unsigned char config[] = {0, 5, 0, 0, 0, 0};
    int erreur;
    erreur = Serial_Open(config);
    Serial_ClearReceiveBuffer();
	Serial_ClearTransmitBuffer();

    Start();
    ML_clear_vram();
    PrintMini(25,31,"Au revoir",1);
    ML_display_vram();
    erreur = Serial_Close(0);
    Sleep(2500);
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}
