extern "C"
{
#include <fxlib.h>
#include "MonochromeLib.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "serial.h"
#include "memory.h"
}
//Fin des Inclusions
//Inclussion des modules

#include "Initialisation.hpp"
#include "Player.hpp"
#include "Sprite.hpp"

//Fin des Inclusions

int SaveSprite( char * adresse , char * nom , void * data , int taille)
{
    char ch[50];
    sprintf(ch,"%s%s", adresse , nom);

    memory_save( ch , (void *) data, taille );

   return 0;
}

const unsigned char *chargerSprite(Sequence info , int i)
{
        char ch[50];
        sprintf(ch, "%s%d", info.Adresse , info.Animation[i] );
        const unsigned char *ptr;
        ptr = ( const unsigned char * ) memory_load(ch);
        return ptr;
}

const unsigned char *chargerSpriteN(Sequence info , int i)
{
        char ch[50];
        sprintf(ch, "%s%dN", info.Adresse , info.Animation[i] );
        const unsigned char *ptr;
        ptr = ( const unsigned char * ) memory_load(ch);
        return ptr;
}

